%define	name	BitchX
%define	version	1.1
%define	release	0
%define	serial	2
%define	prefix	/usr

## Use "--with GTK" to build gtkBitchX package

Summary:	The Ultimate IRC Client
Name:		%{name}
Version:	%{version}
Release:	%{release}
Serial:		%{serial}
Prefix:		%{prefix}
Group:		Applications/Internet
Url:		http://www.bitchx.com/
Vendor:		Colten Edwards <panasync@bitchx.com>
Copyright:	Distributable
Source0:	ftp://ftp.bitchx.com/pub/BitchX/source/ircii-pana-%{version}-final.tar.gz
Source1:	ftp://ftp.bitchx.com/pub/BitchX/source/ircii-pana-%{version}-final.tar.gz.md5
Source2:	ftp://ftp.bitchx.com/pub/BitchX/tcl-o/linux_glibc2-tcl83-bx1.0c20-tcl.o
Source3:	ftp://ftp.bitchx.com/pub/BitchX/tcl-o/linux_glibc2-tcl83-bx1.0c20-tcl.o.md5
Source4:	BitchX.desktop
Source5:	gtkBitchX.desktop
BuildRoot:	%{_tmppath}/%{name}-%{version}-root
Requires:	BitchX-common = %{version}

%description 
BitchX is a VERY heavily modified ircII client.  It includes many things such 
as built in CDCC (XDCC) offering, built in flood protection, etc. It is easier
to script things in BitchX because unlike plain, vanilla ircII, half the 
script does not have to be devoted to changing the appearance of ircII. It also
includes many other new features, such as port scanning, a CD player, a mail
client, etc.

%package	common
Summary:	Help files, documentation, and extras for the BitchX IRC client
Group:		Applications/Internet

%description	common 
These are the help files and other documentation for the BitchX IRC client. It
is required that you install this package so that you at least have all of the
files needed by BitchX. 

This package requires either the BitchX or the gtkBitchX package to do anything
usefull.

%if %{!?_without_GTK:0}%{?_without_GTK:1}
%package -n	gtkBitchX
Summary:	The Ultimate IRC Client
Group:		Applications/Internet
Requires:	BitchX-common = %{version}

%description -n	gtkBitchX
BitchX is a VERY heavily modified ircII client.  It includes many things such 
as built in CDCC (XDCC) offering, built in flood protection, etc. It is easier
to script things in BitchX because unlike plain, vanilla ircII, half the 
script does not have to be devoted to changing the appearance of ircII. It also
includes many other new features, such as port scanning, a CD player, a mail
client, etc.

This package contains the gtk version of BitchX.
%endif

%prep
%setup -q -n %{name}
cp -p %{SOURCE2} ./tcl-linux.o;

# Removing CVS and *~ files.
find . -type f -name '*~'  | xargs rm -rf
find . -type d -name 'CVS' | xargs rm -rf
if [ ! -e source/tcl.o ] && [ -e tcl-linux.o ]; then
	ln -s ../tcl-linux.o source/tcl.o;
fi

%build
export CFLAGS="${RPM_OPT_FLAGS}" CXXFLAGS="${RPM_OPT_FLAGS}";
%ifarch i386 i486 i586 i686
	./configure --prefix=%{prefix} --with-plugins='abot acro aim amp autocycle blowfish cdrom encrypt fserv hint nap pkga possum qbx qmail scan wavplay'
%else
	./configure --prefix=%{prefix} --with-plugins='abot acro aim amp autocycle blowfish cdrom encrypt fserv hint nap pkga possum qbx qmail scan wavplay'
%endif
make
if [ -d BitchX-root ]; then rm -rf BitchX-root; fi
make prefix=${RPM_BUILD_DIR}/BitchX/BitchX-root%{prefix} install

%if %{!?_without_GTK:0}%{?_without_GTK:1}
%ifarch i386 i486 i586 i686
	./configure --prefix=%{prefix} --with-gtk --enable-sound --with-plugins='nicklist xmms'
%else
	./configure --prefix=%{prefix} --with-gtk --enable-sound --with-plugins='nicklist xmms'
%endif
make
make prefix=${RPM_BUILD_DIR}/BitchX/BitchX-root%{prefix} install
install -s -m 755 source/gtkBitchX ${RPM_BUILD_DIR}/BitchX/BitchX-root%{prefix}/bin/gtkBitchX-%{version}
ln -sf gtkBitchX-%{version} ${RPM_BUILD_DIR}/BitchX/BitchX-root%{prefix}/bin/gtkBitchX;
install -s -m 755 dll/nicklist/nicklist.so ${RPM_BUILD_DIR}/BitchX/BitchX-root%{prefix}/lib/bx/plugins
install -s -m 644 script/actplug.gmz ${RPM_BUILD_DIR}/BitchX/BitchX-root%{prefix}/lib/bx/script/
install -s -m 644 script/menu.bx ${RPM_BUILD_DIR}/BitchX/BitchX-root%{prefix}/lib/bx/script/
%endif

%install
[ -d ${RPM_BUILD_ROOT} ] && rm -rf ${RPM_BUILD_ROOT};
mkdir -p ${RPM_BUILD_ROOT}

cp -apr ${RPM_BUILD_DIR}/BitchX/BitchX-root%{prefix} ${RPM_BUILD_ROOT}/

(
	cd ${RPM_BUILD_ROOT}%{prefix}/bin;
	[ -f %{name}-%{version}-final ] && mv %{name}-%{version}-final %{name}-%{version};
	ln -sf %{name}-%{version} %{name};
%if %{!?_without_GTK:0}%{?_without_GTK:1}
	ln -sf gtkBitchX-%{version} gtkBitchX;
%endif
)

install -m 644 doc/BitchX.1 ${RPM_BUILD_ROOT}%{prefix}/man/man1

install -d ${RPM_BUILD_ROOT}/usr/share/gnome/apps/Internet
install -m 644 %{SOURCE4} ${RPM_BUILD_ROOT}/usr/share/gnome/apps/Internet
%if %{!?_without_GTK:0}%{?_without_GTK:1}
install -m 644 %{SOURCE5} ${RPM_BUILD_ROOT}%{prefix}/share/gnome/apps/Internet
%endif

install -d ${RPM_BUILD_ROOT}%{prefix}/share/pixmaps
install -m 664 doc/misc/BitchX.png ${RPM_BUILD_ROOT}%{prefix}/share/pixmaps

install -m 644 doc/ircII.servers ${RPM_BUILD_ROOT}%{prefix}/lib/bx

strip --strip-unneeded ${RPM_BUILD_ROOT}%{prefix}/lib/bx/plugins/*.so || true
strip --strip-unneeded ${RPM_BUILD_ROOT}%{prefix}/bin/* || true

%clean
[ -d ${RPM_BUILD_ROOT} ] &&  rm -rf ${RPM_BUILD_ROOT};

%files
%defattr(-,root,root)
%{prefix}/bin/BitchX
%{prefix}/bin/BitchX-%{version}
%{prefix}/lib/bx/wserv
%{prefix}/bin/scr-bx 
%{prefix}/share/gnome/apps/Internet/BitchX.desktop

%files common
%defattr(-,root,root)
%doc COMPILE-PROBLEMS Changelog README* bugs doc/*
%dir %{prefix}/lib/bx
%config %{prefix}/lib/bx/ircII.servers
%{prefix}/lib/bx/BitchX.*
%{prefix}/lib/bx/help

%dir %{prefix}/lib/bx/plugins
%{prefix}/lib/bx/plugins/BitchX.hints
%{prefix}/lib/bx/plugins/autobot.so
%{prefix}/lib/bx/plugins/acro.so
%{prefix}/lib/bx/plugins/aim.so
%{prefix}/lib/bx/plugins/amp.so
%{prefix}/lib/bx/plugins/autocycle.so
%{prefix}/lib/bx/plugins/blowfish.so
%{prefix}/lib/bx/plugins/cdrom.so
%{prefix}/lib/bx/plugins/encrypt.so
%{prefix}/lib/bx/plugins/fserv.so
%{prefix}/lib/bx/plugins/hint.so
%{prefix}/lib/bx/plugins/nap.so
%{prefix}/lib/bx/plugins/pkga.so
%{prefix}/lib/bx/plugins/possum.so
%{prefix}/lib/bx/plugins/qbx.so
%{prefix}/lib/bx/plugins/qmail.so
%{prefix}/lib/bx/plugins/scan.so
%{prefix}/lib/bx/plugins/wavplay.so

%dir %{prefix}/lib/bx/script
%config %{prefix}/lib/bx/script/bxglobal
%config %{prefix}/lib/bx/script/bxtcl.tcl
%{prefix}/lib/bx/script/*.gz
%{prefix}/lib/bx/translation
%{prefix}/share/pixmaps/BitchX.png
%{prefix}/man/man1/BitchX.1.gz

%if %{!?_without_GTK:0}%{?_without_GTK:1}
%files -n gtkBitchX
%defattr(-,root,root)
%{prefix}/bin/gtkBitchX
%{prefix}/bin/gtkBitchX-%{version}
%{prefix}/lib/bx/plugins/nicklist.so
%{prefix}/lib/bx/plugins/xmms.so
%config %{prefix}/lib/bx/script/actplug.gmz
%config %{prefix}/lib/bx/script/menu.bx
%{prefix}/share/gnome/apps/Internet/gtkBitchX.desktop
%endif

%changelog
* Mon Mar 29 2003 Ryan Weaver <ryanw@falsehope.com>
  [BitchX-1.1-0]
- Updated to version 1.1-final. See ChangeLog for details.

* Thu Jul 25 2002 Ryan Weaver <ryanw@falsehope.com>
  [BitchX-1.0c19-2]
- Added tcl.o back in.
- Including md5s of source files from ftp.
- Rebuilt on RedHat 7.3

* Mon Apr  1 2002 Ryan Weaver <ryanw@falsehope.com>
  [BitchX-1.0c19-0]
- Added patch from caf to help with rejoining channels with keys.
  A dummy key is passed for channels without keys instead of an
  empty string.
- Fixed a multiserver bug, where if a non-blocking connect was
  issued and was attached to a window which was later destroyed,
  the connection would continue to be attempted.  Now if no window
  is available for the connect it is aborted.
- Corrected misdocumentation of the /dcc commands, and made /dcc
  -p <port> use the specified port first instead of last.
- Added NOTIFY_INTERVAL although it has a minimum interval of 60
  seconds.
- Applied two patches from caf for timestamping and an improved
  kill message.
- Fixed /lastlog -file so it works again.
- Applied patch from caf which prevents halfops from getting "not
  opped" message.
- Applied patch from jduck to prevent a buffer possible overrun
  in /away.
- Updated configure to search for valid tcl installs.
- Added a /revisions command which reports the CVS revisions of
  the currently running binary.
- Applied slightly modified patch from einride to allow a comma
  separated list of channels to /window bind.
- Fixed a bug where reconnect_server() sets i to -1 which causes
  a buffer underrun.
- Merged in a fix for scrollback crash from epic.
- Applied a patch from caf which corrects the user count in
  funny.
- Applied a patch from Mourgos that corrects some errors and
  ommissions from the mode list.
- Applied a fix from Tilt that allows scr-bx to work on systems
  with an invalid "localhost" address.
- Huey found and fixed a bug in the GUI menu code.
- Dragoon found a bug in randomnick.
- sideshow found a bug in cycle.
- Moved over to using the global function table internally.
- Fixed DCC chat messages going to the wrong window with multiple
  servers.
- Fixed a problem with orphaned server connects.  Orphaned
  connects now get closed on issuing a new /server or /window
  server command.
- simoriah found a typo in mail.c, count_maildir_mail.

* Wed Jan 10 2001 Ryan Weaver <ryanw@infohwy.com>
  [BitchX-1.0c18-1]
- Removed europa plugin.
- Moved xmms plugin to gtkBitchX module.

* Wed Jan 10 2001 Ryan Weaver <ryanw@infohwy.com>
  [BitchX-1.0c18-0]
- Updated to version 1.0c18. See ChangeLog for details.

* Tue Sep 19 2000 Ryan Weaver <ryanw@infohwy.com>
  [BitchX-1.0c17-1]
- Updated to version 1.0c17. See ChangeLog for details.

* Tue Jul  4 2000 Ryan Weaver <ryanw@infohwy.com>
  [BitchX-1.0c16-2]
- Added 1.0c16-format.patch from ftp site.

* Thu Jan 20 2000 Ryan Weaver <ryanw@infohwy.com>
  [BitchX-1.0c16-1]
- Updated to version 1.0c16. See ChangeLog for details.

* Fri Jan  7 2000 Ryan Weaver <ryanw@infohwy.com>
  [BitchX-1.0c15-1]
- Updated to version 1.0c15. See ChangeLog for details.
- Added updated keys.c and network.c from ftp site.
- Made gtkBitchX a sub package. use --define "GTK yes" to build
  with the gtkBitchX package.
- Had to add variable declarations to irc.c and gtkbitchx.c to
  get gtkBitchX to compile.

